/* Gesture.c generated by valac 0.48.13, the Vala compiler
 * generated from Gesture.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc (https://elementary.io)
 *           2020 José Expósito <jose.exposito89@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_NOT_SUPPORTED = 0,
	GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_SWIPE = 1,
	GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_PINCH = 2
} GalaPluginsToucheggGestureType;

#define GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE_TYPE (gala_plugins_touchegg_gesture_type_get_type ())
typedef enum  {
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UNKNOWN = 0,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UP = 1,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_DOWN = 2,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_LEFT = 3,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_RIGHT = 4,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_IN = 5,
	GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_OUT = 6
} GalaPluginsToucheggGestureDirection;

#define GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE_DIRECTION (gala_plugins_touchegg_gesture_direction_get_type ())
typedef enum  {
	GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_UNKNOWN = 0,
	GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHPAD = 1,
	GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHSCREEN = 2
} GalaPluginsToucheggDeviceType;

#define GALA_PLUGINS_TOUCHEGG_TYPE_DEVICE_TYPE (gala_plugins_touchegg_device_type_get_type ())

#define GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE (gala_plugins_touchegg_gesture_get_type ())
#define GALA_PLUGINS_TOUCHEGG_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE, GalaPluginsToucheggGesture))
#define GALA_PLUGINS_TOUCHEGG_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE, GalaPluginsToucheggGestureClass))
#define GALA_PLUGINS_TOUCHEGG_IS_GESTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE))
#define GALA_PLUGINS_TOUCHEGG_IS_GESTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE))
#define GALA_PLUGINS_TOUCHEGG_GESTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE, GalaPluginsToucheggGestureClass))

typedef struct _GalaPluginsToucheggGesture GalaPluginsToucheggGesture;
typedef struct _GalaPluginsToucheggGestureClass GalaPluginsToucheggGestureClass;
typedef struct _GalaPluginsToucheggGesturePrivate GalaPluginsToucheggGesturePrivate;
typedef struct _GalaPluginsToucheggParamSpecGesture GalaPluginsToucheggParamSpecGesture;

struct _GalaPluginsToucheggGesture {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaPluginsToucheggGesturePrivate * priv;
	GalaPluginsToucheggGestureType type;
	GalaPluginsToucheggGestureDirection direction;
	gdouble percentage;
	gint fingers;
	guint64 elapsed_time;
	GalaPluginsToucheggDeviceType performed_on_device_type;
};

struct _GalaPluginsToucheggGestureClass {
	GTypeClass parent_class;
	void (*finalize) (GalaPluginsToucheggGesture *self);
};

struct _GalaPluginsToucheggParamSpecGesture {
	GParamSpec parent_instance;
};

static gpointer gala_plugins_touchegg_gesture_parent_class = NULL;

GType gala_plugins_touchegg_gesture_type_get_type (void) G_GNUC_CONST;
GType gala_plugins_touchegg_gesture_direction_get_type (void) G_GNUC_CONST;
GType gala_plugins_touchegg_device_type_get_type (void) G_GNUC_CONST;
gpointer gala_plugins_touchegg_gesture_ref (gpointer instance);
void gala_plugins_touchegg_gesture_unref (gpointer instance);
GParamSpec* gala_plugins_touchegg_param_spec_gesture (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
void gala_plugins_touchegg_value_set_gesture (GValue* value,
                                              gpointer v_object);
void gala_plugins_touchegg_value_take_gesture (GValue* value,
                                               gpointer v_object);
gpointer gala_plugins_touchegg_value_get_gesture (const GValue* value);
GType gala_plugins_touchegg_gesture_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPluginsToucheggGesture, gala_plugins_touchegg_gesture_unref)
GalaPluginsToucheggGesture* gala_plugins_touchegg_gesture_new (void);
GalaPluginsToucheggGesture* gala_plugins_touchegg_gesture_construct (GType object_type);
static void gala_plugins_touchegg_gesture_finalize (GalaPluginsToucheggGesture * obj);
static GType gala_plugins_touchegg_gesture_get_type_once (void);

static GType
gala_plugins_touchegg_gesture_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_NOT_SUPPORTED, "GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_NOT_SUPPORTED", "not-supported"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_SWIPE, "GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_SWIPE", "swipe"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_PINCH, "GALA_PLUGINS_TOUCHEGG_GESTURE_TYPE_PINCH", "pinch"}, {0, NULL, NULL}};
	GType gala_plugins_touchegg_gesture_type_type_id;
	gala_plugins_touchegg_gesture_type_type_id = g_enum_register_static ("GalaPluginsToucheggGestureType", values);
	return gala_plugins_touchegg_gesture_type_type_id;
}

GType
gala_plugins_touchegg_gesture_type_get_type (void)
{
	static volatile gsize gala_plugins_touchegg_gesture_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_plugins_touchegg_gesture_type_type_id__volatile)) {
		GType gala_plugins_touchegg_gesture_type_type_id;
		gala_plugins_touchegg_gesture_type_type_id = gala_plugins_touchegg_gesture_type_get_type_once ();
		g_once_init_leave (&gala_plugins_touchegg_gesture_type_type_id__volatile, gala_plugins_touchegg_gesture_type_type_id);
	}
	return gala_plugins_touchegg_gesture_type_type_id__volatile;
}

static GType
gala_plugins_touchegg_gesture_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UNKNOWN, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UNKNOWN", "unknown"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UP, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_UP", "up"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_DOWN, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_DOWN", "down"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_LEFT, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_LEFT", "left"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_RIGHT, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_RIGHT", "right"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_IN, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_IN", "in"}, {GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_OUT, "GALA_PLUGINS_TOUCHEGG_GESTURE_DIRECTION_OUT", "out"}, {0, NULL, NULL}};
	GType gala_plugins_touchegg_gesture_direction_type_id;
	gala_plugins_touchegg_gesture_direction_type_id = g_enum_register_static ("GalaPluginsToucheggGestureDirection", values);
	return gala_plugins_touchegg_gesture_direction_type_id;
}

GType
gala_plugins_touchegg_gesture_direction_get_type (void)
{
	static volatile gsize gala_plugins_touchegg_gesture_direction_type_id__volatile = 0;
	if (g_once_init_enter (&gala_plugins_touchegg_gesture_direction_type_id__volatile)) {
		GType gala_plugins_touchegg_gesture_direction_type_id;
		gala_plugins_touchegg_gesture_direction_type_id = gala_plugins_touchegg_gesture_direction_get_type_once ();
		g_once_init_leave (&gala_plugins_touchegg_gesture_direction_type_id__volatile, gala_plugins_touchegg_gesture_direction_type_id);
	}
	return gala_plugins_touchegg_gesture_direction_type_id__volatile;
}

static GType
gala_plugins_touchegg_device_type_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_UNKNOWN, "GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_UNKNOWN", "unknown"}, {GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHPAD, "GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHPAD", "touchpad"}, {GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHSCREEN, "GALA_PLUGINS_TOUCHEGG_DEVICE_TYPE_TOUCHSCREEN", "touchscreen"}, {0, NULL, NULL}};
	GType gala_plugins_touchegg_device_type_type_id;
	gala_plugins_touchegg_device_type_type_id = g_enum_register_static ("GalaPluginsToucheggDeviceType", values);
	return gala_plugins_touchegg_device_type_type_id;
}

GType
gala_plugins_touchegg_device_type_get_type (void)
{
	static volatile gsize gala_plugins_touchegg_device_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_plugins_touchegg_device_type_type_id__volatile)) {
		GType gala_plugins_touchegg_device_type_type_id;
		gala_plugins_touchegg_device_type_type_id = gala_plugins_touchegg_device_type_get_type_once ();
		g_once_init_leave (&gala_plugins_touchegg_device_type_type_id__volatile, gala_plugins_touchegg_device_type_type_id);
	}
	return gala_plugins_touchegg_device_type_type_id__volatile;
}

GalaPluginsToucheggGesture*
gala_plugins_touchegg_gesture_construct (GType object_type)
{
	GalaPluginsToucheggGesture* self = NULL;
	self = (GalaPluginsToucheggGesture*) g_type_create_instance (object_type);
	return self;
}

GalaPluginsToucheggGesture*
gala_plugins_touchegg_gesture_new (void)
{
	return gala_plugins_touchegg_gesture_construct (GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE);
}

static void
gala_plugins_touchegg_value_gesture_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gala_plugins_touchegg_value_gesture_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gala_plugins_touchegg_gesture_unref (value->data[0].v_pointer);
	}
}

static void
gala_plugins_touchegg_value_gesture_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gala_plugins_touchegg_gesture_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gala_plugins_touchegg_value_gesture_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gala_plugins_touchegg_value_gesture_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GalaPluginsToucheggGesture * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gala_plugins_touchegg_gesture_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gala_plugins_touchegg_value_gesture_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	GalaPluginsToucheggGesture ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gala_plugins_touchegg_gesture_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
gala_plugins_touchegg_param_spec_gesture (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	GalaPluginsToucheggParamSpecGesture* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
gala_plugins_touchegg_value_get_gesture (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE), NULL);
	return value->data[0].v_pointer;
}

void
gala_plugins_touchegg_value_set_gesture (GValue* value,
                                         gpointer v_object)
{
	GalaPluginsToucheggGesture * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gala_plugins_touchegg_gesture_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_plugins_touchegg_gesture_unref (old);
	}
}

void
gala_plugins_touchegg_value_take_gesture (GValue* value,
                                          gpointer v_object)
{
	GalaPluginsToucheggGesture * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_plugins_touchegg_gesture_unref (old);
	}
}

static void
gala_plugins_touchegg_gesture_class_init (GalaPluginsToucheggGestureClass * klass,
                                          gpointer klass_data)
{
	gala_plugins_touchegg_gesture_parent_class = g_type_class_peek_parent (klass);
	((GalaPluginsToucheggGestureClass *) klass)->finalize = gala_plugins_touchegg_gesture_finalize;
}

static void
gala_plugins_touchegg_gesture_instance_init (GalaPluginsToucheggGesture * self,
                                             gpointer klass)
{
	self->ref_count = 1;
}

static void
gala_plugins_touchegg_gesture_finalize (GalaPluginsToucheggGesture * obj)
{
	GalaPluginsToucheggGesture * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_TOUCHEGG_TYPE_GESTURE, GalaPluginsToucheggGesture);
	g_signal_handlers_destroy (self);
}

static GType
gala_plugins_touchegg_gesture_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gala_plugins_touchegg_value_gesture_init, gala_plugins_touchegg_value_gesture_free_value, gala_plugins_touchegg_value_gesture_copy_value, gala_plugins_touchegg_value_gesture_peek_pointer, "p", gala_plugins_touchegg_value_gesture_collect_value, "p", gala_plugins_touchegg_value_gesture_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginsToucheggGestureClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugins_touchegg_gesture_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginsToucheggGesture), 0, (GInstanceInitFunc) gala_plugins_touchegg_gesture_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gala_plugins_touchegg_gesture_type_id;
	gala_plugins_touchegg_gesture_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaPluginsToucheggGesture", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gala_plugins_touchegg_gesture_type_id;
}

GType
gala_plugins_touchegg_gesture_get_type (void)
{
	static volatile gsize gala_plugins_touchegg_gesture_type_id__volatile = 0;
	if (g_once_init_enter (&gala_plugins_touchegg_gesture_type_id__volatile)) {
		GType gala_plugins_touchegg_gesture_type_id;
		gala_plugins_touchegg_gesture_type_id = gala_plugins_touchegg_gesture_get_type_once ();
		g_once_init_leave (&gala_plugins_touchegg_gesture_type_id__volatile, gala_plugins_touchegg_gesture_type_id);
	}
	return gala_plugins_touchegg_gesture_type_id__volatile;
}

gpointer
gala_plugins_touchegg_gesture_ref (gpointer instance)
{
	GalaPluginsToucheggGesture * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
gala_plugins_touchegg_gesture_unref (gpointer instance)
{
	GalaPluginsToucheggGesture * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GALA_PLUGINS_TOUCHEGG_GESTURE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

